#region Copyright (c) 2007, Andy Hume <andyhume32@yahoo.co.uk>
/************************************************************************************
'
' Copyright  2007, Andy Hume
'
' This software is provided 'as-is', without any express or implied warranty. In no 
' event will the authors be held liable for any damages arising from the use of this 
' software.
' 
' Permission is granted to anyone to use this software for any purpose, including 
' commercial applications, and to alter it and redistribute it freely, subject to the 
' following restrictions:
'
' 1. The origin of this software must not be misrepresented; you must not claim that 
' you wrote the original software. If you use this software in a product, an 
' acknowledgment (see the following) in the product documentation is required.
'
' Copyright  2007, Andy Hume
'
' 2. Altered source versions must be plainly marked as such, and must not be 
' misrepresented as being the original software.
'
' 3. This notice may not be removed or altered from any source distribution.
'
'***********************************************************************************/
#endregion

#region Using directives

using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;

#endregion

namespace NetcfTestRunner
{
    /// <summary>
    /// Summary description for form.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
#if FX1_1
          public virtual bool InvokeRequired { get { return true; } }
#endif
        
        internal Label label1;
        private Button buttonShowSelectedMessage;
        internal Button buttonSelectedClass;
        internal ComboBox comboBox1;
        internal Button buttonStop;
        internal Button buttonAllClasses;
        internal ListBox listBox1;

        NetcfTestRunnerWorkings m_workings;
        private Button buttonSave;
        internal SaveFileDialog saveFileDialog1;
        private MenuItem menuItemRunAll;
        private MenuItem menuItem2;
        private MenuItem menuItemLoadAssembly;
        internal OpenFileDialog openFileDialogTesteeAssembly;

        /// <summary>
        /// Main menu for the form.
        /// </summary>
        private System.Windows.Forms.MainMenu mainMenu1;

        public Form1()
        {
            InitializeComponent();
            m_workings = new NetcfTestRunnerWorkings(this);
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.menuItemRunAll = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItemLoadAssembly = new System.Windows.Forms.MenuItem();
            this.label1 = new System.Windows.Forms.Label();
            this.buttonShowSelectedMessage = new System.Windows.Forms.Button();
            this.buttonSelectedClass = new System.Windows.Forms.Button();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.buttonStop = new System.Windows.Forms.Button();
            this.buttonAllClasses = new System.Windows.Forms.Button();
            this.listBox1 = new System.Windows.Forms.ListBox();
            this.buttonSave = new System.Windows.Forms.Button();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.openFileDialogTesteeAssembly = new System.Windows.Forms.OpenFileDialog();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.Add(this.menuItemRunAll);
            this.mainMenu1.MenuItems.Add(this.menuItem2);
            // 
            // menuItemRunAll
            // 
            this.menuItemRunAll.Text = "Run all";
            this.menuItemRunAll.Click += new System.EventHandler(this.buttonAllClasses_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.MenuItems.Add(this.menuItemLoadAssembly);
            this.menuItem2.Text = "Menu";
            // 
            // menuItemLoad
            // 
            this.menuItemLoadAssembly.Text = "Load...";
            this.menuItemLoadAssembly.Click += new System.EventHandler(this.menuItemLoadAssembly_Click);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(125, 245);
            this.label1.Size = new System.Drawing.Size(111, 20);
            this.label1.Text = "label1";
            // 
            // buttonShowSelectedMessage
            // 
            this.buttonShowSelectedMessage.Location = new System.Drawing.Point(4, 245);
            this.buttonShowSelectedMessage.Size = new System.Drawing.Size(57, 20);
            this.buttonShowSelectedMessage.Text = "S&how...";
            this.buttonShowSelectedMessage.Click += new System.EventHandler(this.buttonShowSelectedMessage_Click);
            // 
            // buttonSelectedClass
            // 
            this.buttonSelectedClass.Location = new System.Drawing.Point(82, 4);
            this.buttonSelectedClass.Size = new System.Drawing.Size(72, 20);
            this.buttonSelectedClass.Text = "Se&lected";
            this.buttonSelectedClass.Click += new System.EventHandler(this.buttonSelectedClass_Click);
            // 
            // comboBox1
            // 
            this.comboBox1.Location = new System.Drawing.Point(4, 30);
            this.comboBox1.Size = new System.Drawing.Size(232, 22);
            this.comboBox1.GotFocus += new System.EventHandler(this.comboBox1_GotFocus);
            // 
            // buttonStop
            // 
            this.buttonStop.Location = new System.Drawing.Point(164, 4);
            this.buttonStop.Size = new System.Drawing.Size(72, 20);
            this.buttonStop.Text = "Sto&p";
            this.buttonStop.Click += new System.EventHandler(this.buttonStop_Click);
            // 
            // buttonAllClasses
            // 
            this.buttonAllClasses.Location = new System.Drawing.Point(4, 4);
            this.buttonAllClasses.Size = new System.Drawing.Size(72, 20);
            this.buttonAllClasses.Text = "&All classes";
            this.buttonAllClasses.Click += new System.EventHandler(this.buttonAllClasses_Click);
            // 
            // listBox1
            // 
            this.listBox1.Location = new System.Drawing.Point(0, 58);
            this.listBox1.Size = new System.Drawing.Size(240, 184);
            // 
            // buttonSave
            // 
            this.buttonSave.Location = new System.Drawing.Point(67, 245);
            this.buttonSave.Size = new System.Drawing.Size(52, 20);
            this.buttonSave.Text = "&Save...";
            this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.FileName = "NETCFv1 NUnit log.txt";
            // 
            // openFileDialogTesteeAssembly
            // 
            this.openFileDialogTesteeAssembly.Filter = "DLLs (*.dll)|*.dll|Apps (*.exe)|*.exe|All files (*.*)|*.*";
            // 
            // Form1
            // 
            this.ClientSize = new System.Drawing.Size(240, 268);
            this.Controls.Add(this.buttonSave);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.buttonShowSelectedMessage);
            this.Controls.Add(this.buttonSelectedClass);
            this.Controls.Add(this.comboBox1);
            this.Controls.Add(this.buttonStop);
            this.Controls.Add(this.buttonAllClasses);
            this.Controls.Add(this.listBox1);
            this.Menu = this.mainMenu1;
            this.MinimizeBox = false;
            this.Text = "NetcfTestRunner CFv1";
            this.Load += new System.EventHandler(this.Form1_Load);

        }

        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main()
        {
            Application.Run(new Form1());
        }

        private void buttonShowSelectedMessage_Click(object sender, EventArgs e)
        {
            m_workings.buttonShowSelectedMessage_Click(sender, e);
        }

        private void buttonSelectedClass_Click(object sender, EventArgs e)
        {
            m_workings.buttonSelectedClass_Click(sender, e);
        }

        private void comboBox1_GotFocus(object sender, EventArgs e)
        {
            m_workings.comboBox1_GotFocus(sender, e);
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            m_workings.buttonStop_Click(sender, e);
        }

        private void buttonAllClasses_Click(object sender, EventArgs e)
        {
            m_workings.buttonAllClasses_Click(sender, e);
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {
            m_workings.buttonSave_Click(sender, e);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            m_workings.Form1_Load(sender, e);
        }

        private void menuItemLoadAssembly_Click(object sender, EventArgs e)
        {
            m_workings.menuItemLoadAssembly_Click(sender, e);
        }

    }



}

